/********************************************************************************
Copyright (C), Sinowealth Electronic. Ltd.
Author: 	Sino
Version: 	V0.0
Date: 		2020/04/26
History:
	V2.0	2020/04/26		 Preliminary
********************************************************************************/
#include "MCURegister.h"
#include "C51_TYPE.H"
#include "Flash.h"
#include <intrins.h>
#include <ABSACC.H>

U8 ucMcuFlashWrValid;


/*************************************************************************************************
* : McuFlashEraseSector
*   : McuFlashAddrʼַMcuTypeCODEEEPROM
* ֵ: 
*   : Sector
*************************************************************************************************/
void McuFlashEraseSector(U32 xdata McuFlashAddr, U8 xdata McuType)
{
    FLASHCON = McuType;
    XPAGE = McuFlashAddr>>8;
	
        IB_CON1	 = 0xE6;
	if(!EA)		//ֹд
	{
        IB_CON2	 = 0x05;
		if(FLASHCON == McuType)		//ֹд
		{
        IB_CON3	 = 0x0A;
			if(ucMcuFlashWrValid == 0x55)		//ֹд
			{
        IB_CON4	 = 0x09;
		if(XPAGE == (McuFlashAddr>>8))	//ֹд
		{
			IB_CON5	 = 0x06;
			_nop_();
			_nop_();
			_nop_();
			_nop_();
		}
    }
		}
}

    FLASHCON = MCU_TYPE_CODE;
}


/*************************************************************************************************
* : McuFlashBlankCheck
*   : McuFlashAddrʼַ
* ֵ: 0ȫ0Eraseʧܣ1ȫ0Eraseɹ
*   : Erase1SectorǷȫΪ0
*************************************************************************************************/
BOOL McuFlashBlankCheck(U32 xdata McuFlashAddr, U8 xdata McuType)
{
	BOOL Result = 1;
    U16 i;
	
    FLASHCON = McuType;
    for(i=0; i<MCU_CODE_SECTOR_SIZE; i++)
    {
        if(CBYTE[McuFlashAddr+i] != 0x00)
        {
            Result = 0;
			break;
        }
    }
    FLASHCON = MCU_TYPE_CODE;
	
    return Result;
}


/*************************************************************************************************
* : McuFlashWrOneByte
*   : McuFlashAddrʼַWrDataдע
* ֵ: 
*   : д1ֽ
*************************************************************************************************/
void McuFlashWrOneByte(U32 xdata McuFlashAddr, U8 xdata WrData, U8 xdata McuType)
{
    FLASHCON = McuType;
    XPAGE = McuFlashAddr>>8;
    IB_OFFSET = McuFlashAddr % 256;
    
    IB_DATA	 = WrData;
        IB_CON1	 = 0x6E;
	if(!EA)		//ֹд
	{
        IB_CON2	 = 0x05;
		if(FLASHCON == McuType)		//ֹд
		{
        IB_CON3	 = 0x0A;
			if(ucMcuFlashWrValid == 0x55)		//ֹд
			{
        IB_CON4	 = 0x09;
		if(XPAGE == (McuFlashAddr>>8))	//ֹд
		{
			IB_CON5	 = 0x06;
			_nop_();
			_nop_();
			_nop_();
			_nop_();
					_nop_();
				}
			}
		}
    }
	
    FLASHCON = MCU_TYPE_CODE;
}


/*************************************************************************************************
* : McuFlashRdOneByte
*   : McuFlashAddrȡCODEĵַ
* ֵ: صǰCodeֽ
*   : 1ֽ
*************************************************************************************************/
U8 McuFlashRdOneByte(U32 xdata McuFlashAddr, U8 xdata McuType)
{
    U8 GetData = 0;
    
    FLASHCON = McuType;
	GetData = CBYTE[McuFlashAddr];
    FLASHCON = MCU_TYPE_CODE;
    return GetData;
}				


/*************************************************************************************************
* : BootProgram
*   : 
* ֵ: 
*   : BootErase->Program->Verify
          ÿ1SectorдݣУ
*************************************************************************************************/
U8 BootProgram(void)
{
    U8  i, McuCode, McuFlashType;
	U16 j;
	U32 McuFlashAddr;
	
	for(i=0; i<IAP_BK_CODE_SIZE/MCU_CODE_SECTOR_SIZE; i++)                      //ӦóSectorΪλ
	{
        BootMcuWdtClear();
		if(i < IAP_CODE_SIZE/MCU_CODE_SECTOR_SIZE)                              //ǰCODE29K
		{
			McuFlashType = MCU_TYPE_CODE;                                       //IAPCODE
			McuFlashAddr = IAP_CODE_START_ADDR + (U16)i*MCU_CODE_SECTOR_SIZE;   //ӵ5Kʼ
		}
		else
		{
			McuFlashType = MCU_TYPE_E2P;                                        //IAPEEPROM
			McuFlashAddr = (U16)i*MCU_CODE_SECTOR_SIZE - IAP_CODE_SIZE;
		}
		ucMcuFlashWrValid = 0x55;
		McuFlashEraseSector(McuFlashAddr, McuFlashType);                        //ֽΪλ
		if(McuFlashBlankCheck(McuFlashAddr, McuFlashType))                      //Ҫ
		{
			for(j=0; j<MCU_CODE_SECTOR_SIZE; j++)                               //ݰAPPӦַ
			{
				McuCode = McuFlashRdOneByte(IAP_BK_CODE_START_ADDR+j+(U16)i*MCU_CODE_SECTOR_SIZE, MCU_TYPE_CODE);	//yangweilei ˴̻ΪflashȡݣAPPȡCODE(1ֽ)
				McuFlashWrOneByte(McuFlashAddr+j, McuCode, McuFlashType);		//CODEдAPPִ
				if(McuCode != McuFlashRdOneByte(McuFlashAddr+j, McuFlashType))	//УдĴ
				{
					return (BOOT_PGR_WR_ERR);
				}
			}
		}
		else
		{
			return (BOOT_PGR_ERASE_ERR);
		}
	}
	
	return (BOOT_PGR_OK);
}


/*************************************************************************************************
* : BootUpgradeCode
*   : 
* ֵ: 
*   : BootErase->Program->Verify
*************************************************************************************************/
BOOL BootUpgradeCode(void)
{
	BOOL Result = 1;
		
	if(BootProgram() == BOOT_PGR_OK)
	{
		McuFlashEraseSector(BOOT_FLG_START_ADDR, MCU_TYPE_CODE);                //дɹԶ־λ
		Result = McuFlashBlankCheck(BOOT_FLG_START_ADDR, MCU_TYPE_CODE);        //Ҫ
	}
	else
	{
		Result = 0;
	}
    
	return Result;
}

