/********************************************************************************
Copyright (C), Sinowealth Electronic. Ltd.
Author: 	Sino
Version: 	V0.0
Date: 		2020/04/26
History:
	V2.0	2020/04/26		 Preliminary
********************************************************************************/
#include "MCURegister.h"
#include "C51_TYPE.H"
#include "Flash.h"
#include "IapIsp.h"

BOOL bIapIspFlg;            //0ʾǰִIAP1ʾǰִISP
BOOL bHandsheakOkFlg;
BOOL bUartSndOverFlg;
U16 uiUartRcvChkSum;
U8	ucUartErrCode;
U8	ucUartBufPT;
U32	ulIapDataPtr;
U32	ulIapChksum;
U32	ulIapRecDataLen;
U8	ucIapIndexBk;
U8	ucIapRestCommand;
U8	xdata ucUartBuf[150];
U8	xdata ucIapBuf[MCU_CODE_SECTOR_SIZE];

extern void UARTInit(void);
/*************************************************************************************************
* : UartSendAck
*   : 
* ֵ: 
*   : Slaveݲɺ󣬿ʼ
*************************************************************************************************/
void UartSendAck(void)
{
    U8 i, DataBak;
    U16 CheckSum = 0;

    ucUartBuf[LENGTH] = 0x00;
    ucUartBuf[COMMAND] = 0x0B;
    
    DataBak = ucUartBuf[SOURCE];                                            //ԴIDĿID
	ucUartBuf[SOURCE] = ucUartBuf[TARGET];
	ucUartBuf[TARGET] = DataBak;
	
	for(i=2; i<(ucUartBuf[LENGTH]+7); i++)
	{
		CheckSum += ucUartBuf[i];
	}
	
	ucUartBuf[7+ucUartBuf[LENGTH]] = (U8)CheckSum;
	ucUartBuf[8+ucUartBuf[LENGTH]] = (U8)(CheckSum>>8);
	
	bUartSndOverFlg = 0;
	UartTxEn(ucUartBuf[ucUartBufPT]);
}


/*************************************************************************************************
* : IapHandShake
*   : 
* ֵ: 
*   : Э飬IAPISPд
          bIapIspFlg: 0--IAP1--ISP
*************************************************************************************************/
void IapHandShake(void)
{
	ucUartBuf[INDEXES] = 0;
	if(ucUartBuf[DATA]=='I' && ucUartBuf[DATA+1]=='A' && ucUartBuf[DATA+2]=='P')
	{
		bIapIspFlg = IAP_MODE;
        bHandsheakOkFlg = 1;
	}
	else if(ucUartBuf[DATA]=='I' && ucUartBuf[DATA+1]=='S' && ucUartBuf[DATA+2]=='P')
	{
		bIapIspFlg = ISP_MODE;
        bHandsheakOkFlg = 1;
	}
	else
	{
		ucUartBuf[INDEXES] = IAPERROR_HANDSHAKE;                            //ʧ
        bHandsheakOkFlg = 0;
	}
}


/*************************************************************************************************
* : IapBeginAck
*   : 
* ֵ: 
*   : IAPISPʼCODEı30K
*************************************************************************************************/
void IapBeginAck(void)
{
    U8 i, SectorNum, McuFlashType;
	U32 McuFlashAddr;
    
	ulIapDataPtr = 0;
	ulIapChksum = 0;
	ulIapRecDataLen = 0;
	ulIapRecDataLen = ((U32)ucUartBuf[DATA+3]<<24)                          //ݳ
					| ((U32)ucUartBuf[DATA+2]<<16)
					| ((U32)ucUartBuf[DATA+1]<<8)
					| (U32)ucUartBuf[DATA];

    if(!bHandsheakOkFlg)
    {
        ucUartBuf[INDEXES] = IAPERROR_HANDSHAKE;                            //ʧ
    }
    
    if((ulIapRecDataLen > IAP_BK_CODE_SIZE) && (bIapIspFlg == IAP_MODE))
	{
		ucUartBuf[INDEXES] = IAPERROR_SIZE;                                 //ݳȲIAPISPȣĬΪ쳣
	}
    else if((ulIapRecDataLen > ISP_CODE_SIZE) && (bIapIspFlg == ISP_MODE))
	{
		ucUartBuf[INDEXES] = IAPERROR_SIZE;                                 //ݳȲIAPISPȣĬΪ쳣
	}
	else
	{
		ucUartBuf[INDEXES] = 0;                                             //Ԥظɹ
		ucIapIndexBk = 0;
        
//1. ǰISPȲBOOTı־ȻBOOT_FLG_ISP_ADDдISP_FLG־0xA5
        ucMcuFlashWrValid = 0x55;                                           //MCU Codeɲ־ֹд
        McuFlashEraseSector(BOOT_FLG_START_ADDR, MCU_TYPE_CODE);
        if(McuFlashBlankCheck(BOOT_FLG_START_ADDR, MCU_TYPE_CODE))          //Ҫ
        {
            if(bIapIspFlg == ISP_MODE)
            {
                McuFlashWrOneByte(BOOT_FLG_ISP_ADDR, ISP_FLG, MCU_TYPE_CODE);
                if(McuFlashRdOneByte(BOOT_FLG_ISP_ADDR, MCU_TYPE_CODE) != ISP_FLG)
                {
                    ucUartBuf[INDEXES] = IAPERROR_WR;                       //Writeʧ
                }
            }
        }
        else
        {
            ucUartBuf[INDEXES] = IAPERROR_ERASE;                            //Eraseʧ
        }
        ucMcuFlashWrValid = 0;
		
//2. IAPISPȲSectorISPҪEEPROM
		if(ucUartBuf[INDEXES] == 0)							                //ucUartBuf[INDEXES]
		{
			SectorNum = ulIapRecDataLen/MCU_CODE_SECTOR_SIZE;
            for(i=0; i<SectorNum; i++)						                //ȲCODESector
			{
                McuFlashType = MCU_TYPE_CODE;                               //Ĭϲflash
				if(bIapIspFlg == ISP_MODE)
				{
                    McuFlashAddr = ISP_CODE_START_ADDR;                     //ISPʼַ
				}
				else
				{
					McuFlashAddr = IAP_BK_CODE_START_ADDR;                  //IAPʼַ
				}
                McuFlashAddr += (U16)i*512;                                 //ȷҳʼַ
                
				if(bIapIspFlg == ISP_MODE)									//ISPģʽֱӲEEPROM
				{
					if(i>=(SectorNum-APP_PARA_SIZE/MCU_CODE_SECTOR_SIZE))	//EEPROMsector
					{
						McuFlashType = MCU_TYPE_E2P;
						McuFlashAddr = (U16)(i+APP_PARA_SIZE/MCU_CODE_SECTOR_SIZE-SectorNum)*512;
					}
				}
				
				ucMcuFlashWrValid = 0x55;					                //MCU Codeɲ־ֹд
				McuFlashEraseSector(McuFlashAddr, McuFlashType);
				if(!McuFlashBlankCheck(McuFlashAddr, McuFlashType))	        //Ҫ
				{
					ucUartBuf[INDEXES] = IAPERROR_ERASE;                    //Eraseʧ
				}
				ucMcuFlashWrValid = 0;
			}
		}
        else
        {
            ucUartBuf[INDEXES] = IAPERROR_INDEX;
        }
	}
}


/*************************************************************************************************
* : IapWrSector
*   : 
* ֵ: 
*   : д1Sector
*************************************************************************************************/
BOOL IapWrSector(void)
{
	BOOL Result = 1;
	U16 i;
	U32 McuFlashAddr;
	U8 McuFlashType;
	
	for(i=0; i<MCU_CODE_SECTOR_SIZE; i++)                                   //д1sector
	{
		McuFlashType = MCU_TYPE_CODE;
		if(bIapIspFlg == ISP_MODE)                                          //ISP
		{
			McuFlashAddr = ISP_CODE_START_ADDR + ulIapDataPtr;
			if(McuFlashAddr >= (ulIapRecDataLen+BOOT_CODE_SIZE-APP_PARA_SIZE))
			{
				McuFlashAddr = McuFlashAddr - (ulIapRecDataLen+BOOT_CODE_SIZE-APP_PARA_SIZE);
				McuFlashType = MCU_TYPE_E2P;                                //ISPEEPROM
			}
		}
		else
		{
			McuFlashAddr = IAP_BK_CODE_START_ADDR + ulIapDataPtr;
		}
		McuFlashWrOneByte(McuFlashAddr, ucIapBuf[i], McuFlashType);
		if(ucIapBuf[i] != McuFlashRdOneByte(McuFlashAddr, McuFlashType))
		{
			Result = 0;
			break;
		}
		ulIapDataPtr++;
	}
	
	return Result;
}


/*************************************************************************************************
* : IapReceiveData
*   : 
* ֵ: 
*   : ݣͬʱдMCU CODE
*************************************************************************************************/
void IapReceiveData(void)
{
	U16 i;
	U8 j;
	U32 McuFlashAddr;
	U8 McuFlashType;
	
    bHandsheakOkFlg = 0;
    
    if( ((ucUartBuf[INDEXES]<ucIapIndexBk) || (ucUartBuf[INDEXES]>(ucIapIndexBk+4))) && (ucUartBuf[INDEXES] != 0) )    //yangweilei
	{
		ucUartBuf[INDEXES] = IAPERROR_INDEX;                                //жǷжǷ񳬳Χ
	}
	else
	{
		ucIapIndexBk = ucUartBuf[INDEXES];
        ucUartBuf[INDEXES] = 0;
		if(ucUartBuf[LENGTH] == 0)
		{
			ulIapDataPtr += 512;                                            //ݵĳΪ0ʾǰ128ֽΪ0ָӣд(150mS/1K)
		}
		else
		{
			j = ucIapIndexBk % 4;                                           //ĿǰݶsectorΪ512bytesÿδ128bytesԶΪ4
            for(i=0; i<ucUartBuf[LENGTH]; i++)
			{
				ucIapBuf[i+(U16)j*ucUartBuf[LENGTH]] = ucUartBuf[DATA+i];
			}
			if(j == 3)                                                      //1sectorŽд
			{
                ucMcuFlashWrValid = 0x55;                                   //MCU Codeɲ־ֹд
				if(!IapWrSector())                                          //һдsectorдһ
				{
                    if(ulIapDataPtr >= MCU_CODE_SECTOR_SIZE)
                    {
                        ulIapDataPtr -= MCU_CODE_SECTOR_SIZE;               //ָ뷵صSectorʼ
					}
                    else
                    {
                        ulIapDataPtr = 0;
                    }
                    
                    McuFlashType = MCU_TYPE_CODE;                           //ĬCODE
					if(bIapIspFlg == ISP_MODE)                              //ISP
					{
						McuFlashAddr = ISP_CODE_START_ADDR + ulIapDataPtr;
						if(McuFlashAddr >= (ulIapRecDataLen+BOOT_CODE_SIZE-APP_PARA_SIZE))
						{
							McuFlashAddr = McuFlashAddr - (ulIapRecDataLen+BOOT_CODE_SIZE-APP_PARA_SIZE);
							McuFlashType = MCU_TYPE_E2P;                    //ISPEEPROM
						}
					}
					else
					{
                        McuFlashAddr = IAP_BK_CODE_START_ADDR + ulIapDataPtr;
					}
                    ucMcuFlashWrValid = 0x55;
					McuFlashEraseSector(McuFlashAddr, McuFlashType);
					if(McuFlashBlankCheck(McuFlashAddr, McuFlashType))      //Ҫ
					{
						if(!IapWrSector())                                  //дδ򷵻ظλ쳣
						{
							ucUartBuf[INDEXES] = IAPERROR_WR;               //д
						}
						else
						{
							goto UpdateChksum;
						}
					}
					else
					{
						ucUartBuf[INDEXES] = IAPERROR_ERASE;                //
					}
				}
				else                                                        //512BytesдȷŸchecksumֵ
				{
UpdateChksum:
					for(j=0; j<MCU_CODE_SECTOR_SIZE/4; j++)                 //checksumҪ32bitSTM32
					{
						ulIapChksum += (((U32)ucIapBuf[j*4+3]<<24)
									  | ((U32)ucIapBuf[j*4+2]<<16)
									  | ((U32)ucIapBuf[j*4+1]<<8)
									  | ((U32)ucIapBuf[j*4+0]));
					}
				}
                
                ucMcuFlashWrValid = 0;
			}
		}
	}
}


/*************************************************************************************************
* : IapRDataVerify
*   : 
* ֵ: 
*   : ֤CheckSumǷȷ
*************************************************************************************************/
void IapRDataVerify(void)
{
	U32 CheckSum = 0;
	
	CheckSum =	  ((U32)ucUartBuf[DATA+3]<<24)                              //ȡλ·У
				| ((U32)ucUartBuf[DATA+2]<<16)
				| ((U32)ucUartBuf[DATA+1]<<8)
				| ((U32)ucUartBuf[DATA+0]);
	
	if(ulIapChksum != CheckSum)                                             //Уʧ
	{
		ucUartBuf[INDEXES] = IAPERROR_CRC;
	}
	else
	{
		ucUartBuf[INDEXES] = 0;                                             //Уɹ
	}
}


/*************************************************************************************************
* : IapCmdReset
*   : 
* ֵ: 
*   : IAPISPProgram֮λ͸λָת0x0000ַ
          ISPBOOTı־ISP
          IAPBOOTı־ͬʱ־һֽд0x5AAPPԶ
*************************************************************************************************/
void IapCmdReset(void)
{
	ucUartBuf[INDEXES] = 0;
	ucIapRestCommand = IAP_CMD_RESET;
	
	ucMcuFlashWrValid = 0x55;                                               //MCU Codeɲ־ֹд
	McuFlashEraseSector(BOOT_FLG_START_ADDR, MCU_TYPE_CODE);
	if(McuFlashBlankCheck(BOOT_FLG_START_ADDR, MCU_TYPE_CODE))              //Ҫ
	{
		if(bIapIspFlg == IAP_MODE)                                          //IAPҪBOOTı־һֽд0x5A
		{
			McuFlashWrOneByte(BOOT_FLG_IAP_ADDR, IAP_FLG, MCU_TYPE_CODE);
			if(McuFlashRdOneByte(BOOT_FLG_IAP_ADDR, MCU_TYPE_CODE) != IAP_FLG)
			{
				ucUartBuf[INDEXES] = IAPERROR_WR;                           //Writeʧ
				ucIapRestCommand = 0;
			}
		}
	}
	else
	{
		ucUartBuf[INDEXES] = IAPERROR_ERASE;                                //ʧ
		ucIapRestCommand = 0;
	}
	ucMcuFlashWrValid = 0;
}


/*************************************************************************************************
* : UartCmdProcess
*   : 
* ֵ: 
*   : IAPISP
*************************************************************************************************/
void UartCmdProcess(void)
{
	ucUartBufPT = 0;
	if(uiUartRcvChkSum != ((ucUartBuf[ucUartBuf[LENGTH]+8]<<8) + ucUartBuf[ucUartBuf[LENGTH]+7]))
	{
		ucUartErrCode |= IAPERROR_CHECKSUM;
	}
	
	if(ucUartErrCode != 0)                                                  //дִ
	{
		ucUartBuf[INDEXES] = ucUartErrCode;
	}
	else
	{
		if(ucUartBuf[COMMAND] == IAP_CMD_HANDSHAKE)                         //IAPISPЭ飬λ
		{
			IapHandShake();
		}
		else if(ucUartBuf[COMMAND] == IAP_CMD_BEGIN)                        //ʼIAPISPCODE/EEPȫ
		{
			IapBeginAck();
		}
		else if(ucUartBuf[COMMAND] == IAP_CMD_TRANS)                        //ݡд롢У
		{
			IapReceiveData();
		}
		else if(ucUartBuf[COMMAND] == IAP_CMD_VERIFY)                       //
		{
			IapRDataVerify();
		}
		else if(ucUartBuf[COMMAND] == IAP_CMD_RESET)
		{
			IapCmdReset();
		}
	}
	
	UartSendAck();
}


/*************************************************************************************************
* : BootIapIsp
*   : 
* ֵ: 
*   : IAPISP
*************************************************************************************************/
void BootIapIsp(void)
{
	ulIapDataPtr = 0;
	ulIapChksum = 0;
	ucIapRestCommand = 0;
	UARTInit();
	while(1)
	{
		#if ((UART_DEFINE >= 1)&&(UART_DEFINE<= 30))
		{
			if(RI)
			{
				//BootMcuWdtClear();                                              //ڸóѭУδյUARTͨѶжͨѶ쳣Ź
				ucUartBuf[ucUartBufPT] = SBUF;
				ucUartBufPT++;
				if(ucUartBufPT >= 140)                                          //ָ벻ᳬ140
				{
					ucUartBufPT = 0;
				}
				if(ucUartBufPT == 1)
				{
					if(ucUartBuf[HEARD1] != 0x5A)                               //֡ͷǷWie0x5AA5
					{
						ucUartBufPT = 0;
					}
	
				}
				else if(ucUartBufPT == 2)
				{
	
					if(ucUartBuf[HEARD2] != 0xA5)
					{
						ucUartBufPT = 0;
					}
					else
					{
						uiUartRcvChkSum = 0;                                    //֡ͷжȷ
						ucUartErrCode = 0;
					}
				}
				else
				{
	
					if(ucUartBufPT < (ucUartBuf[LENGTH]+9))
					{
						if(ucUartBufPT <= (ucUartBuf[LENGTH]+7))
						{
							uiUartRcvChkSum += ucUartBuf[ucUartBufPT-1];
						}
						
						if(ucUartBufPT == (TARGET+1))                           //ID
						{
							
							if(ucUartBuf[TARGET] != IAP_BMSID)
							{
								ucUartBufPT = 0;
							}
						}
						else if(ucUartBufPT == (COMMAND+1))                     //COMMAND
						{						
							if((ucUartBuf[COMMAND] != IAP_CMD_HANDSHAKE)
							&& (ucUartBuf[COMMAND] != IAP_CMD_BEGIN)
							&& (ucUartBuf[COMMAND] != IAP_CMD_TRANS)
							&& (ucUartBuf[COMMAND] != IAP_CMD_VERIFY)
							&& (ucUartBuf[COMMAND] != IAP_CMD_RESET))
							{
								ucUartErrCode |= IAPERROR_CMD;
							}
						}
					}
					else
					{
						BootMcuWdtClear();
						UartCmdProcess();
					}
				}
				RI = 0;
			}
			
			if(TI)
			{
				BootMcuWdtClear();                                              //ڸóѭУδյUARTͨѶжͨѶ쳣Ź
				
				if(ucUartBufPT >= (ucUartBuf[LENGTH]+8))
				{
					UartRxEn();                                                 //Allow UART receive data
					ucUartBufPT = 0;
					ucUartBuf[0] = 0;
					ucUartBuf[1] = 0;
					ucUartBuf[2] = 0;
					bUartSndOverFlg = 1;
				}
				else
				{
					ucUartBufPT++;
					UartTxEn(ucUartBuf[ucUartBufPT]);
				}
	
				TI = 0;
			}
			
			if(ucIapRestCommand == IAP_CMD_RESET)
			{
				BootMcuWdtClear();
				if(bUartSndOverFlg)                                             //Reset֡ظ
				{
					bUartSndOverFlg = 0;
					ucIapRestCommand = 0;
					((void(code*)(void))0x0000)();
				}
			}
		}
		#elif ((UART_DEFINE >= 31)&&(UART_DEFINE<= 60))
		{
			INSCON = 0x40;
			if(RI1)
			{
				//BootMcuWdtClear();                                              //ڸóѭУδյUARTͨѶжͨѶ쳣Ź
				ucUartBuf[ucUartBufPT] = SBUF1;
				INSCON = 0x00;
				ucUartBufPT++;
				if(ucUartBufPT >= 140)                                          //ָ벻ᳬ140
				{
					ucUartBufPT = 0;
				}
				if(ucUartBufPT == 1)
				{
					if(ucUartBuf[HEARD1] != 0x5A)                               //֡ͷǷWie0x5AA5
					{
						ucUartBufPT = 0;
					}
	
				}
				else if(ucUartBufPT == 2)
				{
	
					if(ucUartBuf[HEARD2] != 0xA5)
					{
						ucUartBufPT = 0;
					}
					else
					{
						uiUartRcvChkSum = 0;                                    //֡ͷжȷ
						ucUartErrCode = 0;
					}
				}
				else
				{
	
					if(ucUartBufPT < (ucUartBuf[LENGTH]+9))
					{
						if(ucUartBufPT <= (ucUartBuf[LENGTH]+7))
						{
							uiUartRcvChkSum += ucUartBuf[ucUartBufPT-1];
						}
						
						if(ucUartBufPT == (TARGET+1))                           //ID
						{
							
							if(ucUartBuf[TARGET] != IAP_BMSID)
							{
								ucUartBufPT = 0;
							}
						}
						else if(ucUartBufPT == (COMMAND+1))                     //COMMAND
						{						
							if((ucUartBuf[COMMAND] != IAP_CMD_HANDSHAKE)
							&& (ucUartBuf[COMMAND] != IAP_CMD_BEGIN)
							&& (ucUartBuf[COMMAND] != IAP_CMD_TRANS)
							&& (ucUartBuf[COMMAND] != IAP_CMD_VERIFY)
							&& (ucUartBuf[COMMAND] != IAP_CMD_RESET))
							{
								ucUartErrCode |= IAPERROR_CMD;
							}
						}
					}
					else
					{
						BootMcuWdtClear();
						UartCmdProcess();
					}
				}
				INSCON = 0x40;
				RI1 = 0;
				INSCON = 0x00;
			}
			INSCON = 0x40;
			
			if(TI1)
			{
				INSCON = 0x00;
				BootMcuWdtClear();                                              //ڸóѭУδյUARTͨѶжͨѶ쳣Ź
				
				if(ucUartBufPT >= (ucUartBuf[LENGTH]+8))
				{
					UartRxEn();                                                 //Allow UART receive data
					ucUartBufPT = 0;
					ucUartBuf[0] = 0;
					ucUartBuf[1] = 0;
					ucUartBuf[2] = 0;
					bUartSndOverFlg = 1;
				}
				else
				{
					ucUartBufPT++;
					UartTxEn(ucUartBuf[ucUartBufPT]);
				}
				INSCON = 0x40;
	
				TI1 = 0;
				INSCON = 0x00;
			}
			
			if(ucIapRestCommand == IAP_CMD_RESET)
			{
				BootMcuWdtClear();
				if(bUartSndOverFlg)                                             //Reset֡ظ
				{
					bUartSndOverFlg = 0;
					ucIapRestCommand = 0;
					((void(code*)(void))0x0000)();
				}
			}
		}
		#elif ( UART_DEFINE == 61)
		{
			INSCON = 0x40;
			if(RI2)
			{
				//BootMcuWdtClear();                                              //ڸóѭУδյUARTͨѶжͨѶ쳣Ź
				ucUartBuf[ucUartBufPT] = SBUF2;
				INSCON = 0x00;
				ucUartBufPT++;
				if(ucUartBufPT >= 140)                                          //ָ벻ᳬ140
				{
					ucUartBufPT = 0;
				}
				if(ucUartBufPT == 1)
				{
					if(ucUartBuf[HEARD1] != 0x5A)                               //֡ͷǷWie0x5AA5
					{
						ucUartBufPT = 0;
					}
	
				}
				else if(ucUartBufPT == 2)
				{
	
					if(ucUartBuf[HEARD2] != 0xA5)
					{
						ucUartBufPT = 0;
					}
					else
					{
						uiUartRcvChkSum = 0;                                    //֡ͷжȷ
						ucUartErrCode = 0;
					}
				}
				else
				{
	
					if(ucUartBufPT < (ucUartBuf[LENGTH]+9))
					{
			if(ucUartBufPT <= (ucUartBuf[LENGTH]+7))
			{
				uiUartRcvChkSum += ucUartBuf[ucUartBufPT-1];
			}
						
						if(ucUartBufPT == (TARGET+1))                           //ID
						{
							
							if(ucUartBuf[TARGET] != IAP_BMSID)
							{
								ucUartBufPT = 0;
							}
						}
						else if(ucUartBufPT == (COMMAND+1))                     //COMMAND
						{						
							if((ucUartBuf[COMMAND] != IAP_CMD_HANDSHAKE)
							&& (ucUartBuf[COMMAND] != IAP_CMD_BEGIN)
							&& (ucUartBuf[COMMAND] != IAP_CMD_TRANS)
							&& (ucUartBuf[COMMAND] != IAP_CMD_VERIFY)
							&& (ucUartBuf[COMMAND] != IAP_CMD_RESET))
							{
								ucUartErrCode |= IAPERROR_CMD;
							}
						}
					}
					else
					{
						BootMcuWdtClear();
						UartCmdProcess();
					}
				}
				INSCON = 0x40;
				RI2 = 0;
				INSCON = 0x00;
			}
			INSCON = 0x40;
			
			if(TI2)
			{
				INSCON = 0x00;
				BootMcuWdtClear();                                              //ڸóѭУδյUARTͨѶжͨѶ쳣Ź
				
				if(ucUartBufPT >= (ucUartBuf[LENGTH]+8))
				{
					UartRxEn();                                                 //Allow UART receive data
					ucUartBufPT = 0;
					ucUartBuf[0] = 0;
					ucUartBuf[1] = 0;
					ucUartBuf[2] = 0;
					bUartSndOverFlg = 1;
				}
				else
				{
					ucUartBufPT++;
					UartTxEn(ucUartBuf[ucUartBufPT]);
				}
				INSCON = 0x40;
	
				TI2 = 0;
				INSCON = 0x00;
			}
			
			if(ucIapRestCommand == IAP_CMD_RESET)
			{
				BootMcuWdtClear();
				if(bUartSndOverFlg)                                             //Reset֡ظ
				{
					bUartSndOverFlg = 0;
					ucIapRestCommand = 0;
					((void(code*)(void))0x0000)();
				}
			}
		}
		#endif
	}
}







