/********************************************************************************
Copyright (C), Sinowealth Electronic. Ltd.
Author: 	Sino
Version: 	V0.0
Date: 		2020/04/26
History:
	V2.0	2020/04/26		 Preliminary
********************************************************************************/
#include "Main.h"


U8	xdata	ucChgingCheckCnt;
U8	xdata	ucDsgingCheckCnt;

/*************************************************************************************************
* : CalcuTemp
*   : 
* ֵ: 
*   : ݼֵȡӦ¶ȡ¶ȱΪ¶*10
          ϶25㣬¶ȱֵΪ2731+250
*************************************************************************************************/
U16 CalcuTemp(U16 getdata)
{
	U8	i;
	U16	Temperature;
    U32 Tempcalcu;
 
#if (AFE_ID == 0x34)
    Tempcalcu = (U32)getdata*REF_RES_VAL/(32768-getdata);
#else
	Tempcalcu= (U32)getdata*REF_RES_VAL/(4096-getdata);     //calculte the resistance value of 103AT
    if(Tempcalcu > 10)
    {
        Tempcalcu -= 10;
    }   
#endif
 
	if(Tempcalcu >= NTC103AT[0])                            //look up table to find the resieter  correspond temp
	{
		Temperature = 2731+(TEMP_LOWER_LIMIT *10);			
	}
	else if(Tempcalcu <= NTC103AT[NTC103AT_ARRAY_LEN-1])
	{
		Temperature = 2731+(TEMP_UPPER_LIMIT *10);
	}
	else
	{
		i = ucTempeMiddle;                                  //the ucTempeMiddle must be initialized in InitVar()
		if(Tempcalcu > NTC103AT[i])
		{
			for(i=ucTempeMiddle-1; i>=0; i--)
			{
				if(Tempcalcu <= NTC103AT[i])                //NTC103AT[i+1]<resis<NTC103AT[i]
				{
					break;
				}
			}
		}
		else
		{
			for(i=ucTempeMiddle+1; i<NTC103AT_ARRAY_LEN-1; i++)
			{
				if(Tempcalcu > NTC103AT[i])                 //NTC103AT[i-1]<resis<NTC103AT[i]
				{
					break;
				}
			}
			i--;
		}
		ucTempeMiddle = i;
		
		Temperature = (U16)(ucTempeMiddle-50)*10+(NTC103AT[i]-Tempcalcu)*10/(NTC103AT[i]-NTC103AT[i+1])+2731;	
	}
	return Temperature;	
}


/*************************************************************************************************
* : AfeGetVolAfeGetTempe
*   : 
* ֵ: 
*   : AFEȡѹ¶Ȳɼ
*************************************************************************************************/
BOOL AfeGetVol(void)
{
	U8  i;
	BOOL Result=1;

	for(i=ucCellNumOffset; i<(ucCellNum+ucCellNumOffset); i++)
    {
		if(!AFEReadReg(AFE_CELL1H+2*i, 2, (U8 xdata *)(&AFE.uiCell[i])))	//ͨTWIȡVADCɼĵѹֵ()
        {
			Result = 0;
			return Result;
		}
	}
	
	return Result;
}

BOOL AfeGetTempe(void)
{
	BOOL Result=1;
	
	if(!AFEReadReg(AFE_TS1H, 2, (U8 xdata *)&AFE.uiTS[0]))
	{
		Result = 0;
	}
	if(!AFEReadReg(AFE_TS2H, 2, (U8 xdata *)&AFE.uiTS[1]))
	{
		Result = 0;
    }
    
    if(!AFEReadReg(AFE_TEMP1H, 2, (U8 xdata *)&AFE.uiICTempe[0]))
	{
		Result = 0;
	}
    if(ucCellNum > 5)                                           //6~10Ӧʱ
    {
        if(!AFEReadReg(AFE_TEMP2H, 2, (U8 xdata *)&AFE.uiICTempe[1]))
        {
            Result = 0;
        }
    }
	
	return Result;
}


/*************************************************************************************************
* : AfeCalcuTempe
*   : 
* ֵ: 
*   : ¶ȣuiTempeMaxuiTempeMin
*************************************************************************************************/
void AfeCalcuTempe(void)
{
    U16 TempeData;

	if(AfeGetTempe())
	{
		TempeData = CalcuTemp(AFE.uiTS[0]) + E2siTS0Offset;		//ⲿ¶1
		#if	(UART0_DEFINE != 0)	
		IrqUart0Dis();
		#endif
		#if	(UART1_DEFINE != 0)
		IrqUart1Dis();
		#endif
		#if	(UART2_DEFINE != 0)
		IrqUart2Dis();
		#endif
		Info.uiTS[0] = TempeData;
		#if	(UART0_DEFINE != 0)			
		IrqUart0En();						       		//uart0ж						        
		#endif	
		#if	(UART1_DEFINE != 0)			
		IrqUart1En();						       		//uart1ж						        
		#endif	
		#if	(UART2_DEFINE != 0)
		IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
		#endif
		TempeData = (U32)AFE.uiICTempe[0]*17/10+31;               //ڲ¶1
		#if	(UART0_DEFINE != 0)	
		IrqUart0Dis();
		#endif
		#if	(UART1_DEFINE != 0)
		IrqUart1Dis();
		#endif
		#if	(UART2_DEFINE != 0)
		IrqUart2Dis();
		#endif
		Info.uiICTempe[0] = TempeData;
		
		#if	(UART0_DEFINE != 0)			
		IrqUart0En();						       		//uart0ж						        
		#endif	
		#if	(UART1_DEFINE != 0)			
		IrqUart1En();						       		//uart1ж						        
		#endif
		#if	(UART2_DEFINE != 0)
		IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
		#endif
	  
		if(ucCellNum > 5)										//6~10Ӧʱ
		{    
			TempeData = (U32)AFE.uiICTempe[1]*17/10+31;           //ڲ¶2
			#if	(UART0_DEFINE != 0)	
			IrqUart0Dis();
			#endif
			#if	(UART1_DEFINE != 0)
			IrqUart1Dis();
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2Dis();
			#endif
			Info.uiICTempe[1] = TempeData;
			#if	(UART0_DEFINE != 0)			
			IrqUart0En();						       		//uart0ж						        
			#endif	
			#if	(UART1_DEFINE != 0)			
			IrqUart1En();						       		//uart1ж						        
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
			#endif
		}
	 
		uiTempeMin = Info.uiTS[0];
		uiTempeMax = Info.uiTS[0];
		if(bTempNum)
		{
			TempeData = CalcuTemp(AFE.uiTS[1]) + E2siTS1Offset; //ⲿ¶2
			#if	(UART0_DEFINE != 0)	
			IrqUart0Dis();
			#endif
			#if	(UART1_DEFINE != 0)
			IrqUart1Dis();
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2Dis();
			#endif
			Info.uiTS[1] = TempeData;
			#if	(UART0_DEFINE != 0)			
			IrqUart0En();						       		//uart0ж						        
			#endif	
			#if	(UART1_DEFINE != 0)			
			IrqUart1En();						       		//uart1ж						        
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
			#endif
			
			if(TempeData < uiTempeMin)
			{
				uiTempeMin = TempeData;
			}
			else
			{
				uiTempeMax = TempeData;
			}
		}
	}
}


/*************************************************************************************************
* : AfeCalcuVol
*   : 
* ֵ: 
*   : ѹֵͬСֵuiVadcVmaxuiVadcVminڶж
          ûƽʱŸuiCellVmaxuiCellVminڱж
*************************************************************************************************/
void AfeCalcuVol(void)
{
	U8 i;
	U32 TempPackVol=0, TempCellVol=0;
	uiVadcVmax = 0;					  
	uiVadcVmin = 6000;

	if(AfeGetVol())
	{
		for(i=ucCellNumOffset; i<(ucCellNum+ucCellNumOffset); i++)
		{
			TempCellVol = (U32)AFE.uiCell[i]*CALIVOL/E2uiVPackGain;
		
			if(TempCellVol > uiVadcVmax)            //ֵ&Сֵ
			{
				uiVadcVmax = TempCellVol;
			}
			if(TempCellVol < uiVadcVmin)
			{
				uiVadcVmin = TempCellVol;
			}

			if(!bBalancingFlg)                      //if bCellOpenDecFlag this data will throw away
			{
				#if	(UART0_DEFINE != 0)	
				IrqUart0Dis();
				#endif
				#if	(UART1_DEFINE != 0)
				IrqUart1Dis();
				#endif
				#if	(UART2_DEFINE != 0)
				IrqUart2Dis();
				#endif
				Info.uiVCell[i] = TempCellVol;
				#if	(UART0_DEFINE != 0)			
				IrqUart0En();						       		//uart0ж						        
				#endif	
				#if	(UART1_DEFINE != 0)			
				IrqUart1En();						       		//uart1ж						        
				#endif
				#if	(UART2_DEFINE != 0)
				IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
				#endif
				TempPackVol += TempCellVol;
			}
		}

		if(!bBalancingFlg)
		{
			uiCellVmax = uiVadcVmax;
			uiCellVmin = uiVadcVmin;
			
			#if	(UART0_DEFINE != 0)	
			IrqUart0Dis();
			#endif
			#if	(UART1_DEFINE != 0)
			IrqUart1Dis();
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2Dis();
			#endif
			Info.ulVoltage = TempPackVol;           //Calculate the total voltage
			#if	(UART0_DEFINE != 0)			
			IrqUart0En();						       		//uart0ж						        
			#endif	
			#if	(UART1_DEFINE != 0)			
			IrqUart1En();						       		//uart1ж						        
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
			#endif
		}
	}
}


/*************************************************************************************************
* : CurTempOffset
*   : 
* ֵ: 
*   : ͬоƬ¶ADCĲֵ
*************************************************************************************************/
S16 code siCurTempOffset[2][13]=
{   /**0****1****2****3***4***5***6***7***8***9**10**11**12**/
    {-40, -30, -20, -10,  0, 10, 25, 35, 45, 55, 65, 75, 85},
    { -5,  -4,  -3,  -2, -1, -1,  0,  1,  1,  2,  3,  4,  5},
};

/*************************************************************************************************
* : OffsetCalculate()
*   : 
* ֵ: 
*   : оƬڲ¶ʵʱ0ֵԱ¶ȶADCɼӰ
*************************************************************************************************/
S16 OffsetCalculate(void)
{
    S16 xdata siCadcTempOffset=0;			//20220620
    U8 xdata i;
    
    for(i=0; i<12; i++)
    {
        if(Info.uiICTempe[0] <= (((S32)siCurTempOffset[0][i] + siCurTempOffset[0][i+1]) / 2 * 10 + 2731))
        {
            siCadcTempOffset = siCurTempOffset[1][i];
            break;
        }
    }
    return siCadcTempOffset;
}

/*************************************************************************************************
* : AfeCalcuCurr
*   : 
* ֵ: 
*   : CADCɼĵ
*************************************************************************************************/
void AfeCalcuCurr(void)
{
	U8 i;
	S32 Tempdata=0;

	AFEReadReg(AFE_CURH, 2, (U8 xdata *)&AFE.siCurr);	//ͨTWIȡCADCɼĵֵ

	if((AFE.siCurr&0x1000) != 0)					//bit12жǷΪ(ŵΪֵ)Ϊֵλ0
	{
		AFE.siCurr|=0xE000;
	}
	slCadcCurrent = (S32)CALICUR*(AFE.siCurr-E2siCadcOffset+OffsetCalculate())/E2siCadcGain;

	slCadcCurBuf[ucCadcCnt] = slCadcCurrent;		//ɼ16εȡƽֵΪǰֵ
	if(++ucCadcCnt >= 16)
	{
		ucCadcCnt = 0;
	}
	for(i=0; i<16; i++)
	{
		Tempdata += slCadcCurBuf[i];
	}
	slCadcCurAverage = Tempdata/16;
   
	bDSGING = 0;									//ݵжŵ״̬
	bCHGING = 0;
	if(slCadcCurAverage < (-E2siDfilterCur))
	{
		if(++ucDsgingCheckCnt >= TIME_50MS_500MS)	//ŵ״̬ʱ10*50mS
		{
			ucDsgingCheckCnt = TIME_50MS_500MS;
			bDSGING = 1;
			#if	(UART0_DEFINE != 0)	
			IrqUart0Dis();
			#endif
			#if	(UART1_DEFINE != 0)
			IrqUart1Dis();
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2Dis();
			#endif
			Info.slCurr = slCadcCurAverage;
			#if	(UART0_DEFINE != 0)			
			IrqUart0En();						       		//uart0ж						        
			#endif	
			#if	(UART1_DEFINE != 0)			
			IrqUart1En();						       		//uart1ж						        
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
			#endif
		}
	}
	else if(slCadcCurAverage > E2siDfilterCur)
	{
		if(++ucChgingCheckCnt >= TIME_50MS_500MS)	//ŵ״̬ʱ10*50mS
		{
			ucChgingCheckCnt = TIME_50MS_500MS;
			bCHGING = 1;	 	
			McuPWM2Set(4000, 100);			
			#if	(UART0_DEFINE != 0)	
			IrqUart0Dis();
			#endif
			#if	(UART1_DEFINE != 0)
			IrqUart1Dis();
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2Dis();
			#endif
			Info.slCurr = slCadcCurAverage;
			#if	(UART0_DEFINE != 0)			
			IrqUart0En();						       		//uart0ж						        
			#endif	
			#if	(UART1_DEFINE != 0)			
			IrqUart1En();						       		//uart1ж						        
			#endif
			#if	(UART2_DEFINE != 0)
			IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
			#endif
		}
	}
	else
	{
		#if	(UART0_DEFINE != 0)	
		IrqUart0Dis();
		#endif
		#if	(UART1_DEFINE != 0)
		IrqUart1Dis();
		#endif
		#if	(UART2_DEFINE != 0)
		IrqUart2Dis();
		#endif
		Info.slCurr = 0;
		#if	(UART0_DEFINE != 0)			
		IrqUart0En();						       		//uart0ж						        
		#endif	
		#if	(UART1_DEFINE != 0)			
		IrqUart1En();						       		//uart1ж						        
		#endif
		#if	(UART2_DEFINE != 0)
		IrqUart2En();						        //ʼUART2жʹܣݾʹUARTģѡ
		#endif
	}
}


/*************************************************************************************************
* : AFEInfoProcess
*   : 
* ֵ: 
*   : ÿ50mSȡAFEϢµѹ¶
*************************************************************************************************/
void AFEInfoProcess(void)
{
	AFERdFlg();
	
    bVADCFlg = 0;
    AfeCalcuVol();
    AfeCalcuTempe();

	if(bCADCFlg)				//CADCתɺ󣬲ŶȡAFEϢ
	{
		bCADCFlg = 0;
		AfeCalcuCurr();
	}
}


